#include "AboutWindow.h"
void aboutView::ConvertRGB32ToGreyRGB32(BBitmap* b)
{
	int size = b->BitsLength();
	uint8* src = (uint8*)b->Bits();
	
	for(int i=0;i<b->BitsLength();i+=4)	
	{
		uint8 avg = (uint8)(0.3*src[i+2]+0.59*src[i+1]+0.11*src[i]);
		src[i] = src[i+1] = src[i+2] = avg;
	}
}
aboutView::aboutView(BRect r) : BView(r,"about",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
//	R = b;
//	dec = d;
	int w = 169;
	int h = 73;
	logo = new BBitmap(BRect(0,0,w,h),B_RGB32);
	logo->SetBits(betex_logo_small,(w+1)*(h+1)*3,0,B_RGB32);
//	if(!b)
//	ConvertRGB32ToGreyRGB32(logo);
}
string GetNext(string s, int offset,int& next_offset)
{
	//bool done = false;
	string tmp = "";
	for(int i=offset;i<s.length();i++)
	{
		if(s[i] == '_')
		{
			next_offset = i+1;
			return tmp;	
		}
		else
			tmp += s[i];
	}
	next_offset = s.length();
	return tmp;
}	
void aboutView::Draw(BRect r)
{
			BFont font(be_bold_font);
			font.SetSize(12);
			SetFont(&font);
			r = Bounds();
			float offset = 80;
			
			BFont fixed(be_fixed_font);
			fixed.SetSize(12);
			MovePenTo((r.Width()-logo->Bounds().Width())/2,0);
			DrawBitmap(logo);//,BRect(80,0,80+logo->Bounds().Width()*3/4,logo->Bounds().Height()*3/4));
			MovePenTo((r.Width()-logo->Bounds().Width())/4,0);

				MovePenBy(0,100);
				BPoint p = PenLocation();
				//int tks_size = 31;
				DrawString("BeTeX Beta 2 by Brent Miszalski");//.\nThanks to:\n\tEli Dayan\n\tMichael Pfeiffer\n");
 				MovePenTo(p);
 				MovePenBy(0,20);
 				p = PenLocation();
 				DrawString("Thanks To:   Eli Dayan");
 				MovePenTo(p);
 				MovePenBy(font.StringWidth("Thanks To:   "),20);
 				DrawString("Michael Pfeiffer");
 			//	MovePenTo(p);
 			//	MovePenBy(0,40);
 			//	DrawString("If you like BeTeX please consider making a Donation");
 			r = Bounds();
 		SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_2_TINT));
		StrokeLine(BPoint(r.left,r.top),BPoint(r.left,r.bottom));
		StrokeLine(BPoint(r.left,r.top),BPoint(r.right,r.top));
		
		SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_DARKEN_2_TINT));
		StrokeLine(BPoint(r.left,r.bottom),BPoint(r.right,r.bottom));
		StrokeLine(BPoint(r.right,r.top+1),BPoint(r.right,r.bottom));
		
	/*	SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_LIGHTEN_1_TINT));
		StrokeLine(BPoint(r.left+1,r.top+1),BPoint(r.left,r.bottom));
		StrokeLine(BPoint(r.left,r.top),BPoint(r.right,r.top));
		
		SetHighColor(tint_color(ui_color(B_PANEL_BACKGROUND_COLOR),B_DARKEN_1_TINT));
		StrokeLine(BPoint(r.left,r.bottom),BPoint(r.right,r.bottom));
		StrokeLine(BPoint(r.right,r.top+1),BPoint(r.right,r.bottom));
	*/	
		
			
			/*if(R)
				DrawString("Registered");
			else
				DrawString("UnRegistered");	
			*/
}
AboutWindow::AboutWindow(BRect r,BMessenger* messenger) : BWindow(r,"About BeTeX",B_FLOATING_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	SetFeel(B_NORMAL_WINDOW_FEEL);
	
	r = Bounds();
	float w = r.Width();
	float h = r.Height();
	int wInc = int(w/(7*2)+1);
	int hInc = int(w/7);
	BRect specRect(Bounds());//0,0,60,r.bottom);
	
	rgb_color red = {255,0,0};
	rgb_color blue = {0,0,255};
		
	top = red;
	tup = true;
	bottom = blue;
	bup = false;

		AddChild(gradient = new zGradientView(specRect,top,bottom));

	
	BRect aboutRect = Bounds();//BRect(r.right+40,50,r.right-40,r.bottom-);
	aboutRect.InsetBy(80,60);
	about = new aboutView(aboutRect);//,"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	about->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	gradient->AddChild(about);
		
		/*specRect.OffsetBy(specRect.Width(),specRect.Height()*3/4);
		specRect.right = r.right;
		specRect.bottom = r.bottom; 
		gradient->AddChild(new zGradientView(specRect,top,bottom));
		*/
	//}
	int bwidth = 50;
	int bheight = 30;
	int bpad = 10;
	BRect btnRect(r.right - (2*bpad) - bwidth,r.bottom - (2*bpad) - bheight,r.right - (2*bpad),r.bottom - (2*bpad));
	fQuit = new BButton(btnRect,"quitbtn","OK",new BMessage(ABOUT_WINDOW_QUIT));
	fQuit->MakeDefault(true);
	gradient->AddChild(fQuit);
	
	bwidth = 100;
	btnRect = BRect(r.right - (2*bpad) - bwidth,r.bottom - (2*bpad) - bheight,r.right - (2*bpad),r.bottom - (2*bpad));
	btnRect.OffsetBy(-(50 + (2*bpad)),0);
	
	fHomePage = new BButton(btnRect,"homepagebtn","BeTeX Homepage",new BMessage(GOTO_BETEX_HOMEPAGE));
	gradient->AddChild(fHomePage);
	
	btnRect.OffsetBy(-(80 + (2*bpad)),0);
	btnRect.right = btnRect.left+80;
	fBeBits = new BButton(btnRect,"fBeBitsbtn","BeBits Page",new BMessage(GOTO_BETEX_BEBITSPAGE));
	gradient->AddChild(fBeBits);
	
	btnRect.OffsetBy(-(60 + (2*bpad)),0);
	btnRect.right = btnRect.left+60;
	fDonate = new BButton(btnRect,"fDonatebtn","Donate",new BMessage(GOTO_BETEX_DONATEPAGE));
	gradient->AddChild(fDonate);
	
	
		//fRegister = new BButton();
	//AddChild(new zGradientView(specRect,zWhite,zSpectrumIndigo));
	//specRect.OffsetBy(wInc,0);
	//specRect.top+=hInc;
	
/*	AddChild(new zGradientView(specRect,zWhite,zSpectrumOrange));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
	
	AddChild(new zGradientView(specRect,zWhite,zSpectrumYellow));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
	
	AddChild(new zGradientView(specRect,zWhite,zSpectrumGreen));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
	
	AddChild(new zGradientView(specRect,zWhite,zSpectrumBlue));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
	
	AddChild(new zGradientView(specRect,zWhite,zSpectrumIndigo));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
	
	AddChild(new zGradientView(specRect,zWhite,zSpectrumPurple));
	specRect.OffsetBy(wInc,0);
	specRect.top+=hInc;
*/	
	BMessenger mymsnger(this);
	BMessage increment(UPDATE_COLORS);
	BMessageRunner* run = new BMessageRunner(mymsnger,&increment,UPDATE_TIME,-1);
	
	msgr = messenger;
	
}
AboutWindow::~AboutWindow()
{
	delete msgr;
}
void AboutWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case UPDATE_COLORS:
		{
			if(tup)
			{
				if(top.blue == 255)
				{	top.blue--;
					top.red++;
					tup = false;
				}
				else
				{
					top.blue++;
					top.red--;
				}
			}
			else
			{
				if(top.blue == 0)
				{	top.blue++;
					top.red--;
					tup = true;
				}
				else
				{	
					top.blue--;
					top.red++;
				}
			}
			if(bup)
			{
				if(bottom.blue == 255)
				{	bottom.blue--;
					bottom.red++;
					bup = false;
				}
				else
				{
					bottom.blue++;
					bottom.red--;
				}
			}
			else
			{
				if(bottom.blue == 0)
				{	bottom.blue++;
					bottom.red--;
					bup = true;
				}
				else
				{	
					bottom.blue--;
					bottom.red++;
				}
			}
			
			gradient->SetTop(top);
			gradient->SetBottom(bottom);
			
		}break;
		case ABOUT_WINDOW_QUIT:
		{
			Quit();
		}break;
		case GOTO_BETEX_HOMEPAGE:
		{
			const char * url = "http://misza.beosjournal.org";
			be_roster->Launch("text/html", 1, (char**) &url);
			Quit();
		
		}break;
		case GOTO_BETEX_BEBITSPAGE:
		{
			const char * url = "http://www.bebits.com/app/3919";
			be_roster->Launch("text/html", 1, (char**) &url);
			Quit();
		}break;
		case GOTO_BETEX_DONATEPAGE:
		{
			const char * url = "http://misza.beosjournal.org/donate.html";
			be_roster->Launch("text/html", 1, (char**) &url);
			Quit();
		
		}break;
		
		default:
			BWindow::MessageReceived(msg);
	}
}
void AboutWindow::Quit()
{
	msgr->SendMessage(new BMessage(ABOUT_WINDOW_QUIT));
	BWindow::Quit();
}

