#include "BeTeX.h"
int main(int argc, char** argv)
{
//	LibraryInitializer init;
	BeTeX app;
	app.Run();
	return 0;
}

BeTeX::BeTeX() : BApplication(APP_SIG)
{
	//BAppFileInfo ai;
	//be_roster->GetAppInfo(APP_SIG,&ai);
	BMimeType mime(TEX_FILETYPE);
	BMessage ex_msg;
	bool install = true;
	mime.GetFileExtensions(&ex_msg);
	const char* ext;
	if(ex_msg.FindString("extensions",&ext)==B_OK)
	{
		install = (strcmp(ext,"tex") != 0);
	}
			
	if(mime.InitCheck() == B_OK && install)// && !mime.IsInstalled())
	{
		BMessage msg;
		if(msg.AddString("extensions","tex") == B_OK)
		{
			mime.SetFileExtensions(&msg);
		}
		BBitmap* large_icon = new BBitmap(BRect(0,0,31,31),B_CMAP8);
		large_icon->SetBits(TeXIcon,3072,0,B_CMAP8);
		mime.SetIcon(large_icon,B_LARGE_ICON);
		
		BBitmap* small_icon = new BBitmap(BRect(0,0,15,15),B_CMAP8);
		small_icon->SetBits(SmallTeXIcon,768,0,B_CMAP8);
		mime.SetIcon(small_icon,B_MINI_ICON);
		
		mime.SetLongDescription("TeX/LaTeX Document");
		mime.SetShortDescription("TeX");
		
		mime.SetPreferredApp(APP_SIG);
		
		//Create some attributes......"
		BMessage attr;
		attr.AddString("attr:name","Author");
		attr.AddString("attr:public_name","Author");
		attr.AddInt32("attr:type",B_STRING_TYPE);
		attr.AddBool("attr:public",true);
		attr.AddBool("attr:editable",true);
		
		//Want more attributes for:
		// 1) Document status (draft, incomplete, complete) etc
		// 2) Document Priority (low, medium, high)
		// 3) Something else?
		
		/*attr.AddString("attr:name","Author");
		attr.AddString("attr:public_name","Author");
		attr.AddInt32("attr:type",B_STRING_TYPE);
		attr.AddBool("attr:public",true);
		attr.AddBool("attr:editable",true);
		*/
		
		
		
		mime.Install();
	}
		//I could also add some attributes to the tex file
		//such as author, etc.....
		
	Prefs* prefs = new Prefs();
	main_window = new TWindow(prefs->main_window_rect,prefs);
	main_window->Show();
}
/*BeTeX::~BeTeX()
{
	//if(helper->!= NULL)
	//delete helper->
}*/
void BeTeX::RefsReceived(BMessage* msg)
{
	// main_window->SendMessage(msg);
	BApplication::RefsReceived(msg);
}
bool BeTeX::QuitRequested()
{
	if(main_window->PromptToQuit())
	{
		BString text;
			text << "Are you sure want to quit?";
			
			BAlert* alert = new BAlert("savealert",text.String(),"Cancel","Force Quit",NULL,
			B_WIDTH_AS_USUAL,B_WARNING_ALERT);
			alert->SetShortcut(0,B_ESCAPE);
			int32 button_index = alert->Go();
			switch(button_index)
			{
				case 0:
					return false;
				case 1:
					return true;
			}
			delete alert;
	}
	else
		return true;
}

void BeTeX::AboutRequested()
{
	// main_window->SendMessage(new BMessage(ABOUT_WINDOW_LAUNCH));
	aboutbetex = new BAlert("About BeTeX","BeTeX is a project aimed to create the ultimate\nTeX/LaTeX editor for the BeOS \n By Brent Miszalski \n First slight enhancements by jan__64",
	"COOL",NULL,NULL,B_WIDTH_AS_USUAL,B_IDEA_ALERT);
	aboutbetex->Go();
	//BApplication::AboutRequested();
}
