#include "ColorWindow.h"

FastColor::FastColor(colorView* theWell,BPoint leftTop,color_control_layout matrix,float cellSide,const char* name,BMessage* message = NULL,bool bufferedDrawing = false)
 : BColorControl(leftTop,matrix,cellSide,name,message,bufferedDrawing)
{
	well = theWell;
}

void FastColor::SetValue(int32 v)
{
	BColorControl::SetValue(v);
	well->SetColor(ValueAsColor());
	if(Window())
		well->Render();
}
void FastColor::SetValue(rgb_color c)
{
	BColorControl::SetValue(c);
}

ColorWindow::ColorWindow(BRect r,BMessenger* messenger,rgb_color c) : BWindow(r,"Pick a Colour" B_UTF8_ELLIPSIS,B_FLOATING_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE|B_ASYNCHRONOUS_CONTROLS|B_NOT_CLOSABLE)
{
	SetFeel(B_NORMAL_WINDOW_FEEL);
	
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	msgr = messenger;

	cv = new colorView(BRect(287,10,339,62));
	cv->SetColor(c);
	parent->AddChild(cv);

	ctrlbox = new FastColor(cv,BPoint(10,10),B_CELLS_32x8,4.0,"ctrlbox",new BMessage(COLOURPREFS_UPDATE),true);
	parent->AddChild(ctrlbox);
	ctrlbox->SetValue(c);
	

	int width=50;
	int offset = width + 20;
	
	BRect BtnRect(326-width,62+15,326+10,62+35);

	
	fOk = new BButton(BtnRect,"fOk","Ok",new BMessage(COLOURPREFS_OK));
	parent->AddChild(fOk);
	fOk->MakeDefault(true);

	BtnRect.OffsetBy(-offset,0);

	fCancel = new BButton(BtnRect,"fCancel","Cancel",new BMessage(COLOURPREFS_CANCEL));
	parent->AddChild(fCancel);
	
	
	
	
	/*
	BRect ButtonRect(Bounds());
	ButtonRect.left=fvTextRect.right+50;
	ButtonRect.top=36;//fvTextRect.top;
	ButtonRect.right=ButtonRect.left+ButtonWidth;
	ButtonRect.bottom=ButtonRect.top+ButtonHeight;
	
	find = new BButton(ButtonRect,"find","Find",new BMessage(SEARCH_WINDOW_FIND));
	parent->AddChild(find);
	find->MakeDefault(true);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	replace = new BButton(ButtonRect,"replace","Replace",new BMessage(SEARCH_WINDOW_REPLACE));
	parent->AddChild(replace);
	ButtonRect.OffsetBy(0,ButtonHeight+10);

	replaceall = new BButton(ButtonRect,"replaceall","Replace All",new BMessage(SEARCH_WINDOW_REPLACE_ALL));
	parent->AddChild(replaceall);
	//ButtonRect.OffsetBy(0,ButtonHeight+10);
	*/
}
ColorWindow::~ColorWindow()
{
	delete msgr;
}
void ColorWindow::MessageReceived(BMessage* msg)
{
		if( msg->WasDropped())
		{
			rgb_color*	Rgb;
			ssize_t		Size;
			// if there is RGB color
			if( (msg->FindData("RGBColor", B_RGB_COLOR_TYPE, (const void **)&Rgb, &Size) == B_OK))
			{
				ctrlbox->SetValue(*Rgb);
				cv->SetColor(*Rgb);
				cv->Render();
			
/*			
					BMessage mymsg(COLOURPREFS_UPDATE);
					mymsg.AddData("color",B_RGB_COLOR_TYPE,Rgb,sizeof(rgb_color));
					msgr.SendMessage(&mymsg);
*/
			}
			return;
		}
	switch(msg->what)
	{
		case COLOURPREFS_UPDATE:
		{
			rgb_color updated_colour = ctrlbox->ValueAsColor();
			cv->SetColor(updated_colour);
			cv->Render();
/*			BMessage mymsg(COLOURPREFS_UPDATE);
			mymsg.AddData("color",B_RGB_COLOR_TYPE,Rgb,sizeof(rgb_color));
			msgr.SendMessage(&mymsg);
*/
		}break;
		
		case COLOURPREFS_OK:
		{
			BMessage mymsg(COLOURPREFS_UPDATE);
			rgb_color updated_colour = ctrlbox->ValueAsColor();
			mymsg.AddData("color",B_RGB_COLOR_TYPE,&updated_colour,sizeof(rgb_color));
			msgr->SendMessage(&mymsg);
			Quit();
		}break;
		case COLOURPREFS_CANCEL:
		{
			Quit();
		
		}break;
		/*case SEARCH_WINDOW_FIND:
		{
			BMessage* fmsg = new BMessage(SEARCH_WINDOW_FIND);
			if(findview->TextLength() > 0 
			&& fmsg->AddString("ftext",findview->Text()) == B_OK)
			{
				msgr->SendMessage(fmsg);
			}
		
		}break;
		case SEARCH_WINDOW_REPLACE:	
		{
			BMessage* rmsg = new BMessage(SEARCH_WINDOW_REPLACE);
			if(findview->TextLength() > 0 //&& replaceview->TextLength() > 0
			&& rmsg->AddString("ftext",findview->Text()) == B_OK
			&& rmsg->AddString("rtext",replaceview->Text()) == B_OK			
			&& rmsg->AddBool("all",false)==B_OK)
			{
				msgr->SendMessage(rmsg);
			}
		}break;
		case SEARCH_WINDOW_REPLACE_ALL:
		{
			BMessage* rmsg = new BMessage(SEARCH_WINDOW_REPLACE_ALL);
			if(findview->TextLength() > 0 //&& replaceview->TextLength() > 0
			&& rmsg->AddString("ftext",findview->Text()) == B_OK
			&& rmsg->AddString("rtext",replaceview->Text()) == B_OK			
			&& rmsg->AddBool("all",true)==B_OK)
			{
				
				msgr->SendMessage(rmsg);
			}
		}break;
		*/
		default:
			BWindow::MessageReceived(msg);
	}
}
void ColorWindow::Quit()
{
	msgr->SendMessage(new BMessage(COLOR_WINDOW_QUIT));
	BWindow::Quit();
}

