#include "DimensionWindow.h"


DimensionWindow::DimensionWindow(BRect r,BMessenger* messenger,Prefs* p,uint32 return_msg) : BWindow(r,"Dimensions",B_FLOATING_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE|B_ASYNCHRONOUS_CONTROLS|B_NOT_CLOSABLE)
{
	SetFeel(B_NORMAL_WINDOW_FEEL);
	
	prefs = p;
	
	ret_msg = return_msg;
	
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	msgr = messenger;	

	r = Bounds();
	int bwidth = 50;
	int bheight = 20;
	int bpad = 10;
	BRect btnRect(r.left + (2*bpad)-5,r.bottom - (2*bpad) - bheight,r.left + (2*bpad)+ bwidth-5,r.bottom - (2*bpad));
	
	fOk = new BButton(btnRect,"fOk","Ok",new BMessage(DIM_WINDOW_OK));
	parent->AddChild(fOk);
	fOk->MakeDefault(true);
	btnRect.OffsetBy((50 + (2*bpad)),0);

	fCancel = new BButton(btnRect,"fCancel","Cancel",new BMessage(DIM_WINDOW_CANCEL));
	parent->AddChild(fCancel);
	
	BRect tcRect(bpad,bpad,bpad+100,bpad+20);
	rowsTC = new BTextControl(tcRect,"rowsTC","Rows",prefs->Rows.String(),NULL);
	parent->AddChild(rowsTC);
	tcRect.OffsetBy(0,30);
	colsTC = new BTextControl(tcRect,"colsTC","Columns",prefs->Cols.String(),NULL);
	parent->AddChild(colsTC);
	
	

}
DimensionWindow::~DimensionWindow()
{
	delete msgr;
}
void DimensionWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		
		case DIM_WINDOW_OK:
		{
			BMessage mymsg(ret_msg);
			int max = 20;
			int min = 2;
			BString str = rowsTC->Text();
			int i;
			bool IsStrBad = false;
			for(i=0;i<str.Length();i++)
			{
				if(!isdigit(str[i]))
				{
					IsStrBad = true;	
					break;
				}
			}
			if(!IsStrBad)
			{
				if(atoi(str.String()) > max || atoi(str.String()) < min)
					str = "4";
			}
			if(IsStrBad)
				str = "4";
			
			prefs->Rows = str;
			
			str = colsTC->Text();
			
			IsStrBad = false;
			for(i=0;i<str.Length();i++)
			{
				if(!isdigit(str[i]))
				{
					IsStrBad = true;	
					break;
				}
			}
			if(!IsStrBad)
			{
				if(atoi(str.String()) > max || atoi(str.String()) < min)
					str = "4";
			}
			if(IsStrBad)
				str = "4";
			
			prefs->Cols = str;
			msgr->SendMessage(&mymsg);
			Quit();
		}break;
		case DIM_WINDOW_CANCEL:
		{
			Quit();
		
		}break;
		
		default:
			BWindow::MessageReceived(msg);
	}
}
void DimensionWindow::Quit()
{
	msgr->SendMessage(new BMessage(DIM_WINDOW_QUIT));
	BWindow::Quit();
}

