#include "BrentWindow.h"

#include <string>
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,241,169), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(0,87,206);
	AddChild(parent);
	
	unsigned char* p;
	for(int i=0;i<bin_rel_items;i++)
	{
		bitvec.push_back(new BBitmap(BRect(0,0,bin_rel_data[i].w,bin_rel_data[i].h),B_RGB32));
		p = (unsigned char*)bitvec[i]->Bits();
		for(int k=0;k<bin_rel_data[i].n;k++)
		{
			p[k] = bin_rel_data[i].p[k];
		}
	}
	IsResizing = false;

	Tile(parent,false);
}
void BrentWindow::FrameResized(float w,float h)
{
	if(!IsResizing)
		Tile(parent,true);
}
void BrentWindow::Tile(BView* v,bool IsOnlyResizing)
{
	if(IsResizing)
		return;
		
	IsResizing = true;	
	const int TileSize=23;
	BRect tiler(0,0,TileSize,TileSize);
	BRect f = v->Bounds();
	
	int num_across=0;
	float width = f.Width();
	float twidth = tiler.Width()+1;
	while(width >=0)
	{
		width -= twidth;
		num_across++;
	}
	if(width != -1)
		num_across--;	
				
	int j=1;
	for(int i=0;i<bin_rel_items-2;i++)
	{
			vector<BBitmap*> Icons;
			vector<BPoint> Origins;

			if(!IsOnlyResizing)
			{	
				if(bin_rel_data[i].s == "notin")
				{
					Icons.push_back(bitvec[39]);
					Origins.push_back(BPoint(0,0));
					
					Icons.push_back(bitvec[16]);
					Origins.push_back(BPoint(0,0));
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
				}
				else if(bin_rel_data[i].s == "cong")
				{
					Icons.push_back(bitvec[38]);
					Origins.push_back(BPoint(0,3));
					
					Icons.push_back(bitvec[30]);
					Origins.push_back(BPoint(0,-4));
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
				}
				else if(bin_rel_data[i].s == "models")
				{
					Icons.push_back(bitvec[38]);
					Origins.push_back(BPoint(0,0));
					
					Icons.push_back(bitvec[22]);
					Origins.push_back(BPoint(-6,0));
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
				}
				else if(bin_rel_data[i].s == "neq")
				{
					Icons.push_back(bitvec[38]);
					Origins.push_back(BPoint(0,0));
					
					Icons.push_back(bitvec[39]);
					Origins.push_back(BPoint(0,0));
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
				}
				//if(i != 0)
				else v->AddChild(new TButton(tiler,NULL,bitvec[i]));
				/*else
				{
					vector<BBitmap*> Icons;
					vector<BPoint> Origins;
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(BPoint(0,5));
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
				}*/
			
			
			}
			else
			{
				(v->ChildAt(i))->MoveTo(tiler.LeftTop());
			}
			tiler.OffsetBy(TileSize+1,0);
			
			if(j == num_across)
			{
				tiler.left=0;
				tiler.right=TileSize;
				tiler.OffsetBy(0,TileSize+1);
				j = 0;
			}
			j++;
			
	}

	IsResizing = false;
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}