#include "BrentWindow.h"

#include <string>
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,241,169), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(0,87,206);
	AddChild(parent);
	
	unsigned char* p;
	for(int i=0;i<intl_items;i++)
	{
		bitvec.push_back(new BBitmap(BRect(0,0,intl_data[i].w,intl_data[i].h),B_RGB32));
		p = (unsigned char*)bitvec[i]->Bits();
		for(int k=0;k<intl_data[i].n;k++)
		{
			p[k] = intl_data[i].p[k];
		}
	}
	IsResizing = false;

	Tile(parent,false);
}
void BrentWindow::FrameResized(float w,float h)
{
	if(!IsResizing)
		Tile(parent,true);
}
void BrentWindow::Tile(BView* v,bool IsOnlyResizing)
{
	if(IsResizing)
		return;
		
	IsResizing = true;	
	const int TileSize=23;
	BRect tiler(0,0,TileSize,TileSize);
	BRect f = v->Bounds();
	
	int num_across=0;
	float width = f.Width();
	float twidth = tiler.Width()+1;
	while(width >=0)
	{
		width -= twidth;
		num_across++;
	}
	if(width != -1)
		num_across--;	
				
	int j=1;
	for(int i=0;i<intl_items-4;i++)
	{
			
			if(!IsOnlyResizing)
			{	
				vector<BBitmap*> Icons;
				vector<BPoint> Origins;
		
				int cidx = 30;
				int oidx = 29;
				int aidx = 31;
				int Aidx = 32;
				if(intl_data[i].s == "ograve" 
				|| intl_data[i].s == "oacute"
				|| intl_data[i].s == "ohat"
				|| intl_data[i].s == "otilde"
				|| intl_data[i].s == "obar"
				|| intl_data[i].s == "odot"
				|| intl_data[i].s == "oddot"
				|| intl_data[i].s == "obreve"
				|| intl_data[i].s == "obreve"
				|| intl_data[i].s == "ocheck"
				|| intl_data[i].s == "oddash")
				{		
					
					
						BPoint offset(1,-7);
					if(intl_data[i].s == "odot")
						offset.x = 0;
						
					BPoint ooffset(0,0);
					Icons.push_back(bitvec[oidx]);
					Origins.push_back(ooffset);	
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);

				}	
				else if(intl_data[i].s == "obelowdot" 
				|| intl_data[i].s == "obelowbar")
				{
					BPoint offset(1,7);
					if(intl_data[i].s == "obelowdot")
						offset.x = 0;
					
					BPoint ooffset(0,0);
					Icons.push_back(bitvec[oidx]);
					Origins.push_back(ooffset);
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else if(intl_data[i].s == "cworm")
				{
					BPoint offset(0,7);
					BPoint coffset(0,0);
					Icons.push_back(bitvec[cidx]);
					Origins.push_back(coffset);
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else if(intl_data[i].s == "oworm")
				{
					BPoint offset(0,7);
					BPoint ooffset(0,0);
					Icons.push_back(bitvec[oidx]);
					Origins.push_back(ooffset);
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else if(intl_data[i].s == "aa")
				{
					BPoint offset(0,-7);
					BPoint aoffset(0,0);
					Icons.push_back(bitvec[aidx]);
					Origins.push_back(aoffset);	
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else if(intl_data[i].s == "AA")
				{
					BPoint offset(0,-10);
					BPoint aoffset(0,0);
					Icons.push_back(bitvec[Aidx]);
					Origins.push_back(aoffset);	
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else if(intl_data[i].s == "doubleolink")
				{
					BPoint offset(0,-7);
					//BPoint ooffset(0,0);
					Icons.push_back(bitvec[oidx]);
					Origins.push_back(BPoint(-5,0));
					
					Icons.push_back(bitvec[oidx]);
					Origins.push_back(BPoint(5,0));
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
				}
				else
				{	
					BPoint offset(0,0);
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
					
				}			
				v->AddChild(new TButton(tiler,NULL,Icons,Origins));
			}
			else
			{
				(v->ChildAt(i))->MoveTo(tiler.LeftTop());
			}
			tiler.OffsetBy(TileSize+1,0);
			
			if(j == num_across)
			{
				tiler.left=0;
				tiler.right=TileSize;
				tiler.OffsetBy(0,TileSize+1);
				j = 0;
			}
			j++;
			
	}

	IsResizing = false;
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}