#include "PrefsListView.h"


PrefsListView::PrefsListView(BRect frame,BView* p) : BListView(frame,"listview",B_SINGLE_SELECTION_LIST,B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE)
{
	LastSelectedIndex = -1;
	parent = p;
}
void PrefsListView::SelectionChanged()
{
	
	if(LastSelectedIndex >= 0)
	{
		((PrefsListItem*)ItemAt(LastSelectedIndex))->Hide();
	}

	int current = CurrentSelection();
	if(current >= 0)
	{	
		((PrefsListItem*)ItemAt(current))->Show();
			LastSelectedIndex = current;
	}
	else
	{
		LastSelectedIndex = -1;
			
	
	}	
}
void PrefsListView::Next(int increment)
{
	int items = CountItems();
	if(items > 1)
	{
		int current = CurrentSelection();
		if(current >= 0)
		{
			if(current + increment < items)
			{
				Select(current+increment);
			}
			else
				Select(items-1);
		}
	}
}
void PrefsListView::Prev(int decrement)
{
	int items = CountItems();
	if(items > 1)
	{
		int current = CurrentSelection();
		if(current >= 0)
		{
			if(current - decrement >=0)
			{
				Select(current-decrement);
			}
			else
				Select(0);
		}
	}
}
void PrefsListView::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case B_MOUSE_WHEEL_CHANGED:
		{	//We have a mouse wheel event when the focus is on the desktop.
					float delta_y;
					if(msg->FindFloat("be:wheel_delta_y",&delta_y) == B_OK)
					{
						//int boost=1;
						///if(modifiers() & B_OPTION_KEY)
						//	boost = NoVisibleItems();
						//Wrap-Around is taken care of too.
						if(delta_y > 0)       //move wheel down/back
						{
							Next(1);
						}
						else if(delta_y < 0)	//move wheel up/forward
						{
							Prev(1);	
						}
					}
						
		}break;
		default:
			BListView::MessageReceived(msg);	
		}
}


void PrefsListView::MouseDown(BPoint point)
{
	BListView::MouseDown(point);
}
