#ifndef _TWINDOW_CONSTANTS_H_
#define _TWINDOW_CONSTANTS_H_
//#include "BubbleHelper.h"
//#include "Prefs.h"
#include <View.h>
static bool
CompareColors(const rgb_color a, const rgb_color b)
{
	return a.red == b.red
		&& a.green == b.green
		&& a.blue == b.blue
		&& a.alpha == b.alpha;
}
inline ostream & operator<<(ostream& out,const rgb_color c)
{
	out << "[" << (int)c.red << ":" << (int)c.green << ":" << (int)c.blue << "]";
	return out;
}

inline bool 
operator==(const rgb_color &a, const rgb_color &b)
{
	return CompareColors(a, b);
}

inline bool 
operator!=(const rgb_color &a, const rgb_color &b)
{
	return !CompareColors(a, b);
}

//static BubbleHelper* helper = new BubbleHelper();
const rgb_color Black = {0,0,0};
const rgb_color White = {255,255,255};
const rgb_color Red = {255,0,0};
const rgb_color Blue = {0,0,255};
const rgb_color Magenta = {255,0,255};
const rgb_color Yellow = {254,202,0};
const rgb_color Green = {0,150,113};
const rgb_color Purple = {136,0,156};
const rgb_color NavyBlue = {50,0,150};
const rgb_color Orange = {255,174,0};

//static Prefs* prefs = new Prefs();

#define TEX_FILETYPE "text/x-tex"
//File Menu
const uint32 MENU_FILE_NEW = 'mfnw';
const uint32 MENU_FILE_OPEN = 'mfop';
const uint32 MENU_FILE_OPEN_RECENT = 'mfor';
const uint32 MENU_FILE_OPEN_FOLDER = 'mfof';
const uint32 UPDATE_RECENT_DOCS = 'udrd';
const uint32 MENU_FILE_CLOSE = 'mfcl';
const uint32 MENU_FILE_SAVE = 'mfsv';
const uint32 MENU_FILE_SAVEAS = 'mfsa';

const uint32 MENU_FILE_NEXT_ITEM = 'mfni';
const uint32 MENU_FILE_PREV_ITEM = 'mfpi';

const uint32 MENU_FILE_PAGE_SETUP = 'mfps';
const uint32 MENU_FILE_PRINT = 'mfpr';

const uint32 MENU_FILE_PREFS = 'mfpf';
const uint32 MENU_FILE_ABOUT = 'mfab';
const uint32 MENU_FILE_QUIT = 'mfqt';

//Edit Menu
const uint32 MENU_EDIT_UNDO = 'meun';
const uint32 MENU_EDIT_REDO = 'mere';
const uint32 MENU_EDIT_SEARCH = 'mesh';
const uint32 MENU_EDIT_GOTOLINE = 'megl';

const uint32 MENU_EDIT_COMMENTLINE = 'coml';
const uint32 MENU_EDIT_UNCOMMENTLINE = 'ucml';

//Toolbar Items

const uint32 CMD_DELETE_TEMP_FILES = 'dtfs';
const uint32 CMD_VIEW_LOG_FILE = 'vlgf';


const uint32 CMD_COMPILE_TEXDVI = 'txdv';
const uint32 CMD_COMPILE_DVIPDF = 'dvpf';
const uint32 CMD_COMPILE_DVIPS = 'dvps';
const uint32 CMD_COMPILE_PSPDF = 'pspf';
const uint32 CMD_COMPILE_TEXPDF = 'txpf';
const uint32 CMD_COMPILE_TEXHTML = 'txhl';

const uint32 CMD_LAUNCH_TERMINAL = 'ltrm';
const uint32 CMD_LAUNCH_TRACKER = 'ltrk';


const uint32 CMD_LAUNCH_DVIVIEWER = 'ldvv';
const uint32 CMD_LAUNCH_PSVIEWER = 'lpsv';
const uint32 CMD_LAUNCH_BE_PDF = 'lbpf';
const uint32 CMD_LAUNCH_HTMLVIEWER = 'lhlv';

const uint32 UPDATE_TEXTVIEW_SHORTCUTS = 'udts';


//The following are for TexBar
const uint32 CMD_TBUTTON_INSERT = 'ctbi';
const uint32 HANDLE_HIERARCHY = 'hier';
#define GREEK_SYMBOL_FONT_FAMILY "rtxmi"
#define GREEK_SYMBOL_FONT_STYLE  "Medium"

//lower case letters
const int GREEK_SYMBOL_ALPHA = 11;
const int GREEK_SYMBOL_BETA = 12;
const int GREEK_SYMBOL_GAMMA = 13;
const int GREEK_SYMBOL_DELTA = 14;
const int GREEK_SYMBOL_EPSILON = 15;
const int GREEK_SYMBOL_ZETA = 16;
const int GREEK_SYMBOL_ETA = 17;
const int GREEK_SYMBOL_THETA = 18;
const int GREEK_SYMBOL_IOTA = 19;
const int GREEK_SYMBOL_KAPPA = 20;
const int GREEK_SYMBOL_LAMBDA = 21;
const int GREEK_SYMBOL_MU = 22;
const int GREEK_SYMBOL_NU = 23;
const int GREEK_SYMBOL_XI = 24;
const int GREEK_SYMBOL_PI = 25;
const int GREEK_SYMBOL_RHO = 26;
const int GREEK_SYMBOL_SIGMA = 27;
const int GREEK_SYMBOL_TAU = 28;
const int GREEK_SYMBOL_UPSILON = 29;
const int GREEK_SYMBOL_PHI = 30;
const int GREEK_SYMBOL_CHI = 31;
const int GREEK_SYMBOL_PSI = 32;
const int GREEK_SYMBOL_OMEGA = 33;
//' '
const int GREEK_SYMBOL_SPACE = 65;
//Some Colours

const uint32 ANALYSE_TEXVIEW = 'atxv';
const uint32 PARSE_LINE = 'psln';

const uint32 UPDATE_CLIPBOARD_MENU_STATUS = 'ucms';

const uint32 UPDATE_STATUSBAR = 'udsb';
const uint32 UNDO_HIGHLIGHTING = 'udhl';

const uint32 SEARCH_WINDOW_QUIT = 'swqt';

const uint32 ABOUT_WINDOW_QUIT = 'abwq';
const uint32 ABOUT_WINDOW_LAUNCH = 'abwg';
const uint32 GOTO_BETEX_HOMEPAGE = 'gtbh';
const uint32 GOTO_BETEX_REGISTERPAGE = 'gtbr';
const uint32 SEARCH_WINDOW_FIND = 'swfd';
const uint32 SEARCH_WINDOW_REPLACE = 'swrp';
const uint32 SEARCH_WINDOW_REPLACE_ALL = 'swra';
const uint32 SEARCH_WINDOW_SETTINGS_CHANGED = 'swsc';
//const uint32 FIX_STRVIEW_FOCUS = 'fsvf';
const uint32 FILE_CONTENTS_CHANGED = 'fcch';

const uint32 GTL_WINDOW_GO = 'glwg';
const uint32 GTL_WINDOW_QUIT = 'glwq';

const uint32 PREFS_WINDOW_QUIT = 'pfwq';

const uint32 COLOR_WINDOW_QUIT = 'clrq';
const uint32 COLOURPREFS_UPDATE = 'cput';

const uint32 COLOURPREFS_OK = 'cpok';
const uint32 COLOURPREFS_CANCEL = 'cpcl';

const uint32 PREFS_VIEW_OK = 'pvok';
const uint32 PREFS_VIEW_CANCEL = 'pvcl';
//const uint32 PREFS_VIEW_RESET_DEFAULTS = 'pvrd';

const uint32 PREFS_VIEW_FG_UPDATE = 'pvfg';
const uint32 PREFS_VIEW_BG_UPDATE = 'pvbg';
const uint32 PREFS_VIEW_GEN_UPDATE = 'pvgn';
const uint32 PREFS_VIEW_FORM_UPDATE = 'pvfm';
const uint32 PREFS_VIEW_SPEC_UPDATE = 'pvsc';
const uint32 PREFS_VIEW_MATH_UPDATE = 'pvmh';
const uint32 PREFS_VIEW_COMA_UPDATE = 'pvca';
const uint32 PREFS_VIEW_COMT_UPDATE = 'pvct';
const uint32 PREFS_VIEW_PUNC_UPDATE = 'pvpc';
const uint32 PREFS_VIEW_RESET_COLOR_DEFAULTS = 'pcrd';
const uint32 PREFS_VIEW_RESET_COMMAND_DEFAULTS = 'pcmd';

const uint32 PREFS_VIEW_FONTSIZE_UPDATE = 'pfsu';

const uint32 RESET_ALL_TEX_VIEW_COLORS = 'ratc';
const uint32  RESET_ALL_TEX_VIEW_FONTS = 'ratf';

const uint32 SPAN_WINDOW_LAUNCH = 'spwl';
const uint32 SPAN_WINDOW_QUIT = 'spwq';

#endif

