#include <iostream>
#include <stdio.h>
#include <app/Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <interface/Window.h>  // Be's BWindow class
#include <ScrollView.h>
#include <View.h>
#include "TexView.h"
#include <Font.h>
#include <File.h>
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>
#include <Window.h>
#include <Messenger.h>
#include <Entry.h>
#include "Prefs.h"
//#include "misza_status_view.h"
const int32 MISZA_UNDO = 'mudo';
const int32 MISZA_REDO = 'redo';
//const int32 MISZA_UPDATE_BAR = 'udbr';
//custom BWindow subclass






class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* msg);
		
	private:
		BScrollView* sv;
		TexView* tv;
		BMenuBar* menubar;
			BMenu* editmenu;
					BMenuItem* fundo;
					BMenuItem* fredo;
					BMenuItem* shiftright;
					BMenuItem* shiftleft;
					
};



class TestApp : public BApplication
{
	public:
	TestApp();
	
	public:
	virtual void RefsReceived (BMessage *message);
	virtual void ReadyToRun (void);
	
	public:
	BrentWindow *Window() { return fWindow; };
	
	private:
	BrentWindow *fWindow;
};		


TestApp::TestApp()
	: BApplication ("application/x-vnd.Be-elfexecutable"),
	fWindow(NULL)
{
	fWindow = new BrentWindow;
	fWindow->Show();
}


void
TestApp::RefsReceived (BMessage *message)
{
	BApplication::RefsReceived(message);
}


void
TestApp::ReadyToRun (void)
{
	BApplication::ReadyToRun();
}



//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,650,650), "TexView", B_DOCUMENT_WINDOW, 0)
{
	BView* parent = new BView(Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(216,216,216);
	AddChild(parent);
	//const int StatHeight = 14;

	menubar = new BMenuBar(Bounds(),"menu_bar");

	editmenu = new BMenu("Edit");
	
	editmenu->AddItem(fundo = new BMenuItem("Undo", new BMessage(MISZA_UNDO),'Z'));
	editmenu->AddItem(fredo = new BMenuItem("Redo", new BMessage(MISZA_REDO),'R'));
	editmenu->AddItem(shiftleft = new BMenuItem("Shift Left",new BMessage('shlt'),'['));
	editmenu->AddItem(shiftright = new BMenuItem("Shift Right",new BMessage('shrt'),']'));
	menubar->AddItem(editmenu);
	parent->AddChild(menubar);
	
	BRect mbframe = menubar->Frame();
	float height = mbframe.bottom-mbframe.top;
	
	BRect r = Bounds();
	
	r.top = height+1;
	//r.bottom -= StatHeight;
	//r.OffsetBy(0,height+1);
	//editmenu->AddItem(fredo = new BMenuItem("Redo", new BMessage(MENU_EDIT_REDO),'R'));
	//fundo->SetEnabled(false);
	//fredo->SetEnabled(false);
	//editmenu->AddSeparatorItem();

	rgb_color text_color = {0,0,0};
	BRect tvrect(BRect(0,r.top,r.Width()-B_V_SCROLL_BAR_WIDTH,r.Height()));
	BRect tr(tvrect);
	
	tr.InsetBy(5,5);
	Prefs* prefs = new Prefs();
	tv = new TexView(tvrect,tr,prefs);
	BEntry entry("file.tex");
	if(entry.InitCheck() == B_OK)
	{
		entry_ref ref;
		entry.GetRef(&ref);
		tv->LoadFile(&ref);
	}
	sv = new BScrollView("ScrollView2",tv,B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_FRAME_EVENTS,false,true,B_FANCY_BORDER);
	tv->MakeFocus(true);
	parent->AddChild(sv);

//	BFile file("file.tex",B_READ_ONLY);
//	if (file.InitCheck()/*SetTo(&ref, B_READ_ONLY)*/ == B_OK) 
//	{
//		off_t length;
//		file.GetSize(&length);		// Get the file length;
//		int32 len = length;
//		//tv->SetText(&file,0,len);//,&tra);
//	
//	}
/*	r = Bounds();
	r.top = r.bottom-StatHeight;
	r.right += 1024;
	statbar = new zStatusView(r);
	parent->AddChild(statbar);
	BMessenger msgr(this);
	msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
*/	
	
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		case 'shrt':
		{
			tv->ShiftRight();
		}break;
		case 'shlt':
		{
			tv->ShiftLeft();
		}break;
		case MISZA_UNDO:
		{
			//tv->Undo();
		}break;
		case MISZA_REDO:
		{
			//tv->Redo();
		}break;
		case UPDATE_STATUSBAR:
		{
			BString displayme;

			int32 offset,finish;
			tv->GetSelection(&offset,&finish);
			
			vector<int> sols;
			vector<int> eols;
			tv->FillSolEol(sols,eols,0,tv->TextLength()-1);
			//cout << sols.size() << " " << eols.size() << endl;
			int line=sols.size();
			for(int i=sols.size()-1;i>=0;i--)
			{
				if(offset >= sols[i])
				{	
					line = i;
					break;
				}	
			}
			if(line < 0)
				displayme << "file.tex";
			else
			{
				int position=offset-sols[line];
				line++;
				position++;
				//last lines don't display........ :P
				displayme << "file.tex" << " [" << (int)line << "," << (int) position << "]";
			}				
			cout << displayme.String() << endl;
			//StatusBar->SetText(displayme.String());
			
			/*BString displayme;
			int32 offset,finish;
			tv->GetSelection(&offset,&finish);
			
			int32 sol,eol;
			int32 line = tv->LineAt(offset);//tv->CurrentLine();
			tv->GetSolEol(line,sol,eol);
			int32 position = offset-sol;
			//cout << offset << endl;
			//cout << sol << endl;
			if(sol < 0)
				position = 0;
			//displayme << item->FName() << " - Line " << (int)line;
			displayme << "file.tex" << " [" << (int)line+1 << "," << (int) position+1 << "]";
			statbar->SetText(displayme.String());
			*/
		
		}break;
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}


	


int main(int argc, char ** argv)
{
	//BApplication app("application/x-vnd.Brent-template");//gotta have this
	//Create the window..
	//BWindow* window = new BrentWindow();
	//window->Show();	//shows up the window
	//app.Run();
	
	new TestApp;
	be_app->Run();
	//(new BrentWindow)->Show();
	delete be_app;
	
	return 0;
}
