#include "misza_gradient_view.h"

void PrintColour(rgb_color colour)
{
	cout << "RED = " << (int)colour.red << ", GREEN = " << (int)colour.green << ", BLUE = " << (int)colour.blue << ", ALPHA = "<< (int)colour.alpha << endl;
}
rgb_color GetMidColour(rgb_color c1,rgb_color c2)
{
	rgb_color temp;
	temp.red = (c1.red + c2.red) / 2;
	temp.green = (c1.green + c2.green) / 2;
	temp.blue = (c1.blue + c2.blue) / 2;
	temp.alpha = 255;
	
	return temp;
}
void FillGradientVector(vector<rgb_color>& v,rgb_color c1,rgb_color c2,int hi,int lo)
{

	if(hi != lo-1)//not sure why this guard works :-)
	{
		//calculate middle
		int mid = (lo + hi) /2;
		//store the first mid...
		v[mid] = GetMidColour(c1,c2);
		//I'll take the lo road
		FillGradientVector(v,v[mid],v[lo],mid,lo);
		//I'll take the hi road
		FillGradientVector(v,v[hi],v[mid],hi,mid);
	}
}
zGradientView::zGradientView(BRect frame,rgb_color top,rgb_color bottom,
misza_orientation ori=Z_TOP_BTM) 
: zView(frame,"zGradientView",B_FOLLOW_NONE,B_WILL_DRAW)
{
	Ctop = top;
	Cbottom = bottom;
	Otop = top;
	Obottom = bottom;
	
	theOri = ori;
	SetOrientation(theOri);
	
/*	int w = 169;
	int h = 73;
	logo = new BBitmap(BRect(0,0,w,h),B_RGB32);
	logo->SetBits(betex_logo_small,(w+1)*(h+1)*3,0,B_RGB32);
*/	
}

void zGradientView::Draw(BRect drawRect)
{
	Render();
}

void zGradientView::Render()
{
	bitmap->Lock();
	
		BRect r = bView->Bounds();
	    
		
	switch(theOri)
	{
		
		//verticals
		case Z_TOP_BTM:
		case Z_BTM_TOP:
		{
			bView->SetDrawingMode(B_OP_COPY);
			int size = int(r.bottom - r.top+1);
			
			BPoint x1=r.LeftTop(),x2=r.RightTop();
			BPoint end = r.LeftBottom();
			int i = 0;
			bView->BeginLineArray(size);
			while(x1.y != end.y+1)
			{
				bView->AddLine(x1,x2,v[i]);
	
				i++;
				x1.y++;
				x2.y++;
			}
			bView->EndLineArray();
			
			/*ATTEMPT TO SMOOTH GRADIENT*/
/*			bView->SetDrawingMode(B_OP_BLEND);
			x1=r.LeftTop();
			x2=r.RightTop();
			end = r.LeftBottom();
			i = 0;
		//	x1.y+=2;
		//	x2.y+=2;

			bView->BeginLineArray(size*2);
			while(x1.y != end.y+1)
			{
		
				if(x1.y-1 >= x1.y)
				{
					//bView->AddLine(BPoint(x1.x,x1.y-2),BPoint(x2.x,x2.y-2),v[i++]);
					bView->AddLine(BPoint(x1.x,x1.y-1),BPoint(x2.x,x2.y-1),v[i++]);	
				}
				if(x1.y+1 < end.y+1)
				{
					bView->AddLine(BPoint(x1.x,x1.y+2),BPoint(x2.x,x2.y+2),v[i++]);
					bView->AddLine(BPoint(x1.x,x1.y+1),BPoint(x2.x,x2.y+1),v[i++]);	
				}
				
				//i++;
				x1.y++;
				x2.y++;
			}
			bView->EndLineArray();
*/
	
			bView->SetDrawingMode(B_OP_COPY);
			/*ANOTHER ATTEMPT*/			
/*			bView->SetDrawingMode(B_OP_BLEND);
			x1=r.LeftTop();
			x2=r.RightTop();
			end = r.LeftBottom();
			i = 1;
			bView->BeginLineArray(size);
			while(x1.y != end.y+1)
			{
				if(i != v.size())
					bView->AddLine(x1,x2,v[i++]);
				else
					bView->AddLine(x1,x2,v[v.size()-1]);
				
				x1.y++;
				x2.y++;
			}
			bView->EndLineArray();
			bView->SetDrawingMode(B_OP_COPY);
*/		
			}break;
		
		//horizontals
		case Z_LFT_RHT:
		case Z_RHT_LFT:
		{
			bView->SetDrawingMode(B_OP_COPY);
			int size = int(r.right - r.left+1);
			
			BPoint x1=r.LeftTop(),x2=r.LeftBottom();	
			BPoint end = r.RightTop();
			int i=0;
			bView->BeginLineArray(size);
			while(x1.x != end.x+1)
			{
				bView->AddLine(x1,x2,v[i]);
				i++;
				x1.x++;
				x2.x++;
			}
			bView->EndLineArray();
			/*ATTEMPT TO SMOOTH GRADIENT*/
/*			bView->SetDrawingMode(B_OP_BLEND);
			//int size = r.right - r.left+1;
			
			x1=r.LeftTop();
			x2=r.LeftBottom();	
			end = r.RightTop();
			i=0;
			bView->BeginLineArray(size*2);
			while(x1.x != end.x+1)
			{
		
				if(x1.x-1 >= x1.x)
				{
					//bView->AddLine(BPoint(x1.x,x1.x-2),BPoint(x2.x,x2.x-2),v[i++]);
					bView->AddLine(BPoint(x1.x,x1.y-1),BPoint(x2.x,x2.y-1),v[i++]);	
				}
				if(x1.x+1 < end.x+1)
				{
					//bView->AddLine(BPoint(x1.x,x1.x+2),BPoint(x2.x,x2.x+2),v[i++]);
					bView->AddLine(BPoint(x1.x,x1.y+1),BPoint(x2.x,x2.y+1),v[i++]);	
				}
				
				//i++;
				x1.x++;
				x2.x++;
			}
			bView->EndLineArray();
*/			
			bView->SetDrawingMode(B_OP_COPY);


		}break;
		case Z_RBTM_TLFT:
		case Z_TLFT_RBTM:
		case Z_LBTM_TRHT:
		case Z_TRHT_LBTM:
		{
		
			DrawDiagonal(r,v_vert,v_horiz);
		
		}break;
	
		case Z_CEN_PYR:
		case Z_BOR_PYR:
		{
			BPoint TopMid((r.right - r.left)/2,r.top);
			BPoint RightMid(r.right,(r.bottom - r.top) / 2);
			BPoint BottomMid((r.right - r.left)/2,r.bottom);
			BPoint LeftMid(r.left,(r.bottom - r.top)/ 2);
			BPoint TheMid((r.right - r.left)/2,(r.bottom - r.top)/ 2);
			
			BRect top_left(r.LeftTop(),TheMid);
			BRect top_right(TopMid,RightMid);
			BRect bottom_right(TheMid,r.RightBottom());
			BRect bottom_left(LeftMid,BottomMid);
			
			DrawDiagonal(top_left,pvv_tl,pvh_tl);
			DrawDiagonal(top_right,pvv_tr,pvh_tr);
			DrawDiagonal(bottom_right,pvv_br,pvh_br);
			DrawDiagonal(bottom_left,pvv_bl,pvh_bl);
		
		
		
		}break;		
		
	}
		//bView->MovePenTo(0,0);
		//bView->SetDrawingMode(B_OP_BLEND);
		//bView->DrawBitmap(logo);
		bView->Sync();
		//SetDrawingMode(B_OP_BLEND);
		DrawBitmapAsync(bitmap,Bounds(),Bounds());
		Flush();
		Sync();
	bitmap->Unlock();
}
void zGradientView::SetTop(rgb_color top)
{
	//update the colour
	Ctop = top;
	Otop = top;
	//refill the vector
	Refill();
}	
void zGradientView::SetBottom(rgb_color bottom)
{
	//update the colour
	Cbottom = bottom;
	Obottom = bottom;
	//refill the vector
	Refill();
}

void zGradientView::SetOrientation(misza_orientation ori)
{
	
	theOri = ori;
	
	BRect r = Bounds();
	int vsize = int(r.bottom - r.top +1);
	int hsize = int(r.right - r.left + 1);

	
	switch(theOri)
	{
		//verticals
		case Z_TOP_BTM:
		case Z_BTM_TOP:
		{
			
			vector<rgb_color> v1(vsize);
			int lo = vsize-1;
			int hi = 0;
				
			if(theOri == Z_BTM_TOP)
				SwitchColours();
					
			v1[lo] = Cbottom;
			v1[hi] = Ctop;
			FillGradientVector(v1,Ctop,Cbottom,hi,lo);
			RestoreColours();
			v = v1;
		}break;
		
		//horizontals
		case Z_LFT_RHT:
		case Z_RHT_LFT:
		{	
			
			vector<rgb_color> v1(hsize);
			int lo = hsize-1;
			int hi = 0;
			if(theOri == Z_RHT_LFT)
				SwitchColours();
				
			v1[lo] = Cbottom;
			v1[hi] = Ctop;
			FillGradientVector(v1,Ctop,Cbottom,hi,lo);
			RestoreColours();
			v = v1;
		}break;
		
		//diagonals
		case Z_RBTM_TLFT:
		case Z_TLFT_RBTM:
		case Z_LBTM_TRHT:
		case Z_TRHT_LBTM:
		{	
			
		
			vector<rgb_color> v1(vsize);
			vector<rgb_color> v2(hsize);
			
			FillDiagonal(v1,v2,
			(theOri == Z_RBTM_TLFT || theOri == Z_LBTM_TRHT),
			(theOri == Z_RBTM_TLFT || theOri == Z_TRHT_LBTM));
			v_vert  = v1;
			v_horiz = v2;

		}break;
		
		case Z_CEN_PYR:
		case Z_BOR_PYR:
		{
			
			vsize = vsize / 2 + 1;
			hsize = hsize / 2 + 1;
			
			vector<rgb_color> v1(vsize);
			vector<rgb_color> v2(hsize);
			
			vector<rgb_color> v3(vsize);
			vector<rgb_color> v4(hsize);
			
			vector<rgb_color> v5(vsize);
			vector<rgb_color> v6(hsize);
		
			vector<rgb_color> v7(vsize);
			vector<rgb_color> v8(hsize);
			//v h
			
			//top left//(theOri == Z_CEN_PYR),(theOri == Z_CEN_PYR));
			FillDiagonal(v1,v2,(theOri == Z_CEN_PYR),(theOri == Z_CEN_PYR));
			//top right
			FillDiagonal(v3,v4,theOri == Z_CEN_PYR,theOri == Z_BOR_PYR);
			//bottom left
			FillDiagonal(v5,v6,theOri == Z_BOR_PYR,theOri == Z_CEN_PYR);
			//bottom right
			FillDiagonal(v7,v8,theOri == Z_BOR_PYR,theOri == Z_BOR_PYR);
			
			pvh_tl = v2;
			pvv_tl = v1;

			pvh_tr = v4;
			pvv_tr = v3;

			pvh_bl = v6;
			pvv_bl = v5;

			pvh_br = v8;
			pvv_br = v7;
			
		}break;
		
		
		default:
			cout << "error" << endl;
			break;
	}
	
	
	if(Window()) Render();
}
void zGradientView::SwitchColours()
{
	rgb_color temp  = Ctop;
	Ctop = Cbottom;
	Cbottom = temp;
	//Refill();
}

void zGradientView::Refill()
{
	switch(theOri)
	{
		
		//verticals
		case Z_TOP_BTM:
		case Z_BTM_TOP:
		{
			int lo = v.size()-1;
			int hi = 0;
				
			if(theOri == Z_BTM_TOP)
				SwitchColours();
					
			v[lo] = Cbottom;
			v[hi] = Ctop;
			FillGradientVector(v,Ctop,Cbottom,hi,lo);
			RestoreColours();

		}break;
		
		//horizontals
		case Z_LFT_RHT:
		case Z_RHT_LFT:
		{
			int lo = v.size()-1;
			int hi = 0;
			if(theOri == Z_RHT_LFT)
				SwitchColours();
			v[lo] = Cbottom;
			v[hi] = Ctop;
			FillGradientVector(v,Ctop,Cbottom,hi,lo);
			RestoreColours();
		}break;
		//diagonals
		case Z_RBTM_TLFT:
		case Z_TLFT_RBTM:
		case Z_LBTM_TRHT:
		case Z_TRHT_LBTM:
		{
			FillDiagonal(v_vert,v_horiz,
			(theOri == Z_RBTM_TLFT || theOri == Z_LBTM_TRHT),
			(theOri == Z_RBTM_TLFT || theOri == Z_TRHT_LBTM));
		
		}break;
		
		case Z_CEN_PYR:
		case Z_BOR_PYR:
		{
			//top left
			FillDiagonal(pvv_tl,pvh_tl,(theOri == Z_CEN_PYR),(theOri == Z_CEN_PYR));
			//top right
			FillDiagonal(pvv_tr,pvh_tr,theOri == Z_CEN_PYR,theOri == Z_BOR_PYR);
			//bottom left
			FillDiagonal(pvv_bl,pvh_bl,theOri == Z_BOR_PYR,theOri ==Z_CEN_PYR);
			//bottom right
			FillDiagonal(pvv_br,pvh_br,theOri == Z_BOR_PYR,theOri == Z_BOR_PYR);
			
		}break;
	}
	
	if(Window()) Render();
}

void zGradientView::RestoreColours()
{
	Ctop = Otop;
	Cbottom = Obottom;
}

void zGradientView::AttachedToWindow()
{
	//SetViewColor(Parent()->ViewColor());	
}
void zGradientView::FillDiagonal(vector<rgb_color> &vert_vec,vector<rgb_color> &horiz_vec,bool switch_v,bool switch_h)
{
	 			//fill vertical
			int lo = vert_vec.size()-1;
			int hi = 0;
			if(switch_v)
				SwitchColours();
				
			vert_vec[lo] = Cbottom;
			vert_vec[hi] = Ctop;
			FillGradientVector(vert_vec,Ctop,Cbottom,hi,lo);
			RestoreColours();
			
			//fill horizontal
			lo = horiz_vec.size()-1;
			hi = 0;
			if(switch_h)
				SwitchColours();

			horiz_vec[lo] = Cbottom;
			horiz_vec[hi] = Ctop;
			FillGradientVector(horiz_vec,Ctop,Cbottom,hi,lo);
			RestoreColours();
}
void zGradientView::DrawDiagonal(BRect r,vector<rgb_color>& draw_vert,vector<rgb_color>& draw_horiz)
{
			bView->SetDrawingMode(B_OP_COPY);
			//******DRAW VERTICAL********//
			int size = int(r.bottom - r.top+1);
			BPoint x1=r.LeftTop(),x2=r.RightTop();
			BPoint end = r.LeftBottom();
			int i = 0;
			bView->BeginLineArray(size);
			while(x1.y != end.y+1)
			{
				bView->AddLine(x1,x2,draw_vert[i++]);
	
				x1.y++;
				x2.y++;
			}
			bView->EndLineArray();
			/*ATTEMPT TO SMOOTH GRADIENT*/
/*			bView->SetDrawingMode(B_OP_BLEND);
			x1=r.LeftTop();
			x2=r.RightTop();
			end = r.LeftBottom();
			i = 0;
		//	x1.y+=2;
		//	x2.y+=2;

			bView->BeginLineArray(size);
			while(x1.y != end.y+1)
			{
		
				bView->AddLine(x1,x2,draw_vert[i++]);
				x1.y++;
				x2.y++;
			}
			bView->EndLineArray();
*/
			bView->SetDrawingMode(B_OP_COPY);


			//DrawDiagonal(top_left,r.LeftTop(),LeftMid,TopMid,pvv_tl,pvh_tl);
			
			//bView->EndLineArray();
			//******<DRAW VERTICAL>********//
			//r = bView->Bounds();
			//******DRAW HORIZONTAL********//
			
			bView->SetDrawingMode(B_OP_BLEND);
			size = int(r.right - r.left+1);
			x1=r.LeftTop();
			x2=r.LeftBottom();	
			end = r.RightTop();
			i=0;
			bView->BeginLineArray(size);
			bView->SetDrawingMode(B_OP_BLEND);
			while(x1.x != end.x+1)
			{
				bView->AddLine(x1,x2,draw_horiz[i++]);
				x1.x++;
				x2.x++;
			}
			
			bView->EndLineArray();
			//******<DRAW HORIZONTAL>********//
			
			/*ATTEMPT TO SMOOTH GRADIENT*/
/*			bView->SetDrawingMode(B_OP_BLEND);
			//int size = r.right - r.left+1;
			
			x1=r.LeftTop();
			x2=r.LeftBottom();	
			end = r.RightTop();
			i=0;
			//x1.x+=2;
			//x2.x+=2;
			bView->BeginLineArray(size);
			while(x1.x != end.x+1)
			{
				bView->AddLine(x1,x2,draw_horiz[i++]);
				
				x1.x++;
				x2.x++;
			}
			bView->EndLineArray();
		*/
			bView->SetDrawingMode(B_OP_COPY);

			//bView->SetDrawingMode(B_OP_COPY);
}


